package ws

import (
	"sync"
	"time"

	"git.paulbsd.com/paulbsd/ipbl/src/config"
	"golang.org/x/net/websocket"
)

var listeners sync.Map

func Init(cfg *config.Config) {
}

func welcomeAgents(ws *websocket.Conn, welcome wsWelcome, t string) {
	connectinfoVal, ok := listeners.Load(welcome.Hostname)

	if !ok {
		switch t {
		case "ps":
			connectinfo := connectionInfo{
				ConnectionPS: ws,
				InitDate:     time.Now(),
			}
			listeners.Store(welcome.Hostname, &connectinfo)
		case "rr":
			connectinfo := connectionInfo{
				ConnectionRR: ws,
				InitDate:     time.Now(),
			}
			listeners.Store(welcome.Hostname, &connectinfo)
		}
	} else {
		connectinfo := connectinfoVal.(*connectionInfo)
		switch t {
		case "ps":
			connectinfo.ConnectionPS = ws
		case "rr":
			connectinfo.ConnectionRR = ws
		}
	}
}

func gcConnOnError(ws *websocket.Conn) (err error) {
	listeners.Range(func(index, value interface{}) bool {
		var ci = value.(*connectionInfo)
		if ci.ConnectionPS == ws {
			ci.ConnectionPS.Close()
		}
		if ci.ConnectionRR == ws {
			ci.ConnectionRR.Close()
		}
		listeners.Delete(index)
		return true
	})
	return err
}

type connectionInfo struct {
	ConnectionPS *websocket.Conn
	ConnectionRR *websocket.Conn
	InitDate     time.Time
}

// WSWelcome
type wsWelcome struct {
	Hostname string
}
